/*
 * 商家分类
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class MerchantClassController : BaseController
    {
        public MerchantClassController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 商家分类列表

        /// <summary>
        /// 根据条件查询商家分类列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(MerchantClass data, string right, string MerchantId)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            ViewBag.MerchantId = MerchantId;

            string Condition = "";
            Condition += "ColName:\"" + data.ColName + "\",";
            Condition += "MerchantId:\"" + MerchantId + "\",";

            if (!string.IsNullOrEmpty(Condition))
            { 
                Condition = Condition.TrimEnd(',');
                Condition = ", where: {" + Condition + "}";
            }
            ViewBag.Condition = Condition;
            return View();
        }

        #endregion

        #region 根据条件查询商家分类列表

        /// <summary>
        /// 商家分类列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(MerchantClass data, int page = 1, int limit = 30)
        {
            
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("MerchantId", "1");
            Fields.Add("ColName", "2"); //名称

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("MerchantClass", Fields, "Id desc", "False", page, limit);
            
            return Json(obj);
        }

        #endregion

        #region 增加商家分类

        /// <summary>
        /// 增加或修改商家分类信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right, string MerchantId)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            ViewBag.MerchantId = MerchantId;

            return View();
        }

        #endregion

        #region 增加商家分类

        /// <summary>
        /// 增加或修改商家分类信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(MerchantClass data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            Fields.Add("MerchantId", data.MerchantId);
            Fields.Add("ColName", data.ColName); //名称

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("MerchantClass", Fields, 0);
            AddSysLog(data.Id.ToString(), "MerchantClass", "add");
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 修改商家分类

        /// <summary>
        /// 增加或修改商家分类信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, string MerchantId, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            ViewBag.MerchantId = MerchantId;

            MerchantClass editData = db.MerchantClass.FirstOrDefault(m => m.Id == Id) ?? new MerchantClass();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改商家分类

        /// <summary>
        /// 增加或修改商家分类信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(MerchantClass data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            Fields.Add("MerchantId", data.MerchantId);
            Fields.Add("ColName", data.ColName); //名称

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("MerchantClass", Fields, data.Id);
            AddSysLog(data.Id.ToString(),"MerchantClass","update");
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 删除商家分类信息

        /// <summary>
        /// 删除商家分类信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"MerchantClass","del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Delete("MerchantClass", id);
            }
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"MerchantClass","open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("MerchantClass", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"MerchantClass","close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("MerchantClass", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("MerchantClass", Sort, Id);
            
            AddSysLog(Id.ToString(), "MerchantClass", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count;i++ )
            {
                JsonData dr = list[i];
                
                db.MerchantClass.Add(new MerchantClass()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,
                    
                });
                db.SaveChanges();
            }
            AddSysLog("0", "MerchantClass", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(MerchantClass data)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("ColName", "2"); //名称

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("MerchantClass", Fields, "Id desc", "False", 1, 20000, "", "", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            
            result.Add("Fields", ReturnFields);
            AddSysLog("0", "MerchantClass", "ExportExcel");
            return Json(result);
        }

        #endregion



        public JsonResult GetSelect(int MerchantId)
        {
            List<MerchantClass> list = db.MerchantClass.Where(m => m.MerchantId == MerchantId).OrderByDescending(m => m.Sort).ThenByDescending(m => m.Id).ToList();
            return Json(list);
        }
    }
}
